package com.fp.frontend.controller.pgeneral.gene;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.gene.TgeneCanton;
import com.fp.persistence.pgeneral.gene.TgeneCity;
import com.fp.persistence.pgeneral.gene.TgeneProvince;

/**
 * Clase controladora del bean TgeneCity.
 *
 * @author WPA.
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class CityController extends AbstractController<TgeneCity> {

    private static final long serialVersionUID = 1L;

    public CityController() throws Exception {
        super(TgeneCity.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "CITY";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.description"); // En en string van todos los campos de orden ("t.pk,  t.nombre, t.cpais").

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneCity>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneCity>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            Request request = this.callerhelper.getRequest();
            DtoSave dtosave = super.getDtoSave();
            if (!dtosave.pendingProcess()) {
                return;
            }
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, this.beanalias);
    }

    /**
     * M&eacute;todo que entrega el listado objetos TgeneCity provincias
     *
     * @param countrycode C&oacute;digo de pa&iacute;s
     * @param provincecode C&oacute;digo de provincia
     * @param cantoncode C&oacute;digo de cant&oacute;n
     * @return lrecord Lista de objetos TgeneCity
     */
    public static List<TgeneCity> find(String countrycode, String provincecode, String cantoncode) {
        try {
            CityController cc = new CityController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk.countrycode", countrycode);
            cc.addFilter("pk.provincecode", provincecode);
            cc.addFilter("pk.cantoncode", cantoncode);
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }
    
    public static TgeneCity findOnlyOne(String countrycode, String provincecode, String cantoncode, String citycode) {
        try {
            CityController cc = new CityController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk.countrycode", countrycode);
            cc.addFilter("pk.provincecode", provincecode);
            cc.addFilter("pk.cantoncode", cantoncode);
            cc.addFilter("pk.citycode", citycode);

            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord.get(0);
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }

    /**
     * Metodo para buscar por codigo de ciudad
     *
     * @param citycode
     * @return
     */
    public static List<TgeneCity> findPorCodigo(String countrycode, String provincecode, String cantoncode, String citycode) {
        try {
            CityController cc = new CityController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk.countrycode", countrycode);
            cc.addFilter("pk.provincecode", provincecode);
            cc.addFilter("pk.cantoncode", cantoncode);
            cc.addFilter("pk.citycode", citycode);
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * Metodo para buscar el nombre de la ciudad atraves del codigo
     *
     * @param provincecode
     * @return
     */
    public static String getDescCiudadByCodigo(String countrycode, String provincecode, String cantoncode, String citycode) {
        try {
            if (countrycode == null || provincecode == null || cantoncode == null || citycode == null || countrycode.isEmpty() || provincecode.isEmpty() || cantoncode.isEmpty() || citycode.isEmpty()) {
                return null;
            }
            CityController cc = new CityController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("pk.countrycode", countrycode);
            cc.addFilter("pk.provincecode", provincecode);
            cc.addFilter("pk.cantoncode", cantoncode);
            cc.addFilter("pk.citycode", citycode);
            cc.querydatabase();
            if ((cc.lrecord != null) && !cc.lrecord.isEmpty()) {
                TgeneCity ciudad = cc.lrecord.get(0);
                if (ciudad.getDescription() != null) {
                    return ciudad.getDescription();
                } else {
                    return "";
                }
            }
            return "";
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return "";
        }
    }
}
